
use('evaluation.jar','org.ululatus.sleep.bridges.EvaluationBridge');

$perl_like = {
  local('$proc $reader @output $line $err');
  @output = array();
  
  $proc = [[java.lang.Runtime getRuntime] exec: $1];
  
  if ( checkError($err) || !-istrue $proc ) {
    println( 'error in evaluation handler:' . $err);
    return @output;
  }

  $reader = [new java.io.BufferedReader: [new java.io.InputStreamReader: [$proc getInputStream]]];

  if ( checkError($err) ) {
    println( 'error in evaluation handler:' . $err);
    [$proc destroy];
    return @output;
  }

  # read each line from the process output, stuff it into our array

  $line = [$reader readLine];
  if ( checkError($err) ) {
    println( 'error in evaluation handler:' . $err);
    [$reader close];
    [$proc destroy];
    return @output;
  }
  else {
    push( @output, '' . $line, size(@output));
    $available = 1;
    while ( -istrue $available )
    {
      $line = [$reader readLine];
      push( @output, '' . $line, size(@output));
      if ( checkError($err) ) {
        println( 'error in evaluation handler:' . $err);
        [$reader close];
        [$proc destroy];
        return @output;
      }
      [$reader mark: 2];
      if ( [$reader read] != -1 ) {
        [$reader reset];
      }
      else {
        $available = 0;
      }
    }
  }
  [$reader close];
  return @output;
};

setEvaluationHandler($perl_like);

if ( -isDir @ARGV[0] ) {
  $dir = @ARGV[0];
}
else {
  $dir = '.';
}

@result = `cmd.exe /c dir $dir`;
# comment line above and uncomment next line if you are using linux or cygwin
# @result = `ls -l $dir`;

foreach $result (@result) {
  println($result);
}
