
use('classloader.jar','org.ululatus.sleep.bridges.ClassloaderBridge');
use('evaluation.jar','org.ululatus.sleep.bridges.EvaluationBridge');

addClassPath('hsqldb.jar');
addClassPath('JDBC.jar');
useClass('JDBC');

sub sqlEvaluation {
	local('$resultset @result');
	$resultset = dbQuery( $db_con, $1 );
	@result = dbFetchBuffered( $resultset );
	return @result;
}

$connection = dbConnect('org.hsqldb.jdbcDriver', 'jdbc:hsqldb:presidents', 'SA', '');

if ( checkError($err) ) {
  println('error connecting db: ' . $err);
}

setEvaluationHandler(&sqlEvaluation , $db_con => $connection );
	
# sql statement in backqoutes evaluates to an array
foreach %row (`SELECT * FROM PRESIDENTS`) { 
	println( %row['ID'] . '. ' . "\t" . %row['NAME'] . "\t" . 
					%row['TERMBEGIN'] . '-' . %row['TERMEND'] );
}

# don't keep reference to $connection in the handler
updateEvaluationHandlerVars( $db_con => $null );

dbClose( $connection );
